      //////////////////////////////////
     // SPECSAISIE 1.2                //
    // Written by Andrew Broad       ///
   //  BROADSOFT 2003              ////
  //                               ////
 // ASCII.java (2002:12:02 09:25) ////
/////////////////////////////////////
// Methods of ASCII:             ///
// - static main                 //
//////////////////////////////////

import java.io.*;

/*****************************************************************************
** ASCII is an application class for printing an address-range of an SNA file
** as ASCII text.
*****************************************************************************/

public class ASCII {
	static Memory _memory;

	/********************************************************************/
	// static ASCII.main : String[] -> void
	/*********************************************************************
	** Application entry-point for printing a list of rooms in a Manic
	** Miner game.
	** @param argv The vector of command-line arguments. There should be
	**             three of these: an SNA file, a start-address and a
	**             stop-address.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length < 1 || argv.length > 3) {
			System.err.println("Usage: java ASCII <file.SNA> "
			+ "(<start_address> (<stop_address>))");
			System.exit(1);
		}
		int startAddress= 16357;
		if (argv.length >= 2) {
			try {
				startAddress= Integer.parseInt(argv[1]);
			} catch (NumberFormatException nfe) {
				System.err.println(argv[1] + " doesn't parse"
				+ " as an integer!");
				System.exit(1);
			}
		}
		int stopAddress= 65535;
		if (argv.length >= 2) {
			try {
				stopAddress= Integer.parseInt(argv[2]);
			} catch (NumberFormatException nfe) {
				System.err.println(argv[2] + " doesn't parse"
				+ " as an integer!");
				System.exit(1);
			}
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);

		for (int a= startAddress; a <= stopAddress; a++) {
			byte c= _memory._memory[a];
			if (c < 32) c= 32;
			System.out.print((char)c);
		}
	}
}
