      ////////////////////////////////////
     // SPECSAISIE                      //
    // Written by Andrew Broad         ///
   //  BROADSOFT 2000                ////
  //                                 ////
 // BGB_JSW.java (2000:05:05 09:50) ////
///////////////////////////////////////
// Methods of BGB-JSW:             ///
// - static main                   //
////////////////////////////////////

import java.io.*;

/*****************************************************************************
** RoomsJSW is an application class for detecting occurrences of the block
** graphics bug in Jet Set Willy.
*****************************************************************************/

public class BGB_JSW {
	static Memory _memory;

	/********************************************************************/
	// static BGB_JSW.detectBGB : void -> void
	/*********************************************************************
	** Detects occurrences of the block graphics bug in a JSW game. This
	** bug occurs when a colour attribute in a room occurs as a byte in a
	** pixel-pattern before its proper occurrence as an attribute byte.
	*********************************************************************/

	private static void detectBGB () {
		for (int r= 0; r <= 63; r++) {
System.out.println("\n\n[ROOM " + r + "]");
			int rad= 49152 + 256*r;
			//JSW_Room room= new JSW_Room(_memory, rad);
			for (int a= 169; a <= 206; a+= 9) {
System.out.println("\na == " + a);
				byte c= _memory._memory[rad + a];
System.out.println("PEEK(" + rad + "+" + a + ") == " + c);
				for (int b= 160; b < a; b+= 9) {
System.out.print("b+i == ");
					for (int i= 1; i <= 8; i++) {
System.out.print((b+i) + " ");
						if (_memory._memory[rad + b+i]
						    == c)
						{
							System.out.print
							("BGB ");
						}
					}
System.out.println();
				}
			}
//System.out.println();
		}
	}

	/********************************************************************/
	// static BGB_JSW.main : String[] -> void
	/*********************************************************************
	** Application entry-point for detecting the block graphics bug in a
	** Jet Set Willy game.
	** @param argv The vector of command-line arguments. There should be
	**             one of these: an SNA file of the Jet Set Willy game.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 1) {
			System.err.println("Usage: java BGB_JSW <file.SNA>");
			System.exit(1);
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		detectBGB();
	}
}