      ////////////////////////////////////////
     // SPECSAISIE 1.2                      //
    // Written by Andrew Broad             ///
   //  BROADSOFT 2003                    ////
  //                                     /////
 // BinaryToSNA.java (2002:12:23 15:20) /////
////////////////////////////////////////////
// Methods of BinaryToSNA:              ///
// - static main                        //
/////////////////////////////////////////

import java.io.*;
import java.util.*;

/*****************************************************************************
** BinaryToSNA is an application class for converting a raw binary file to a
** SNA file, by sewing the binary onto an existing SNA file.
*****************************************************************************/

public class BinaryToSNA {
	/********************************************************************/
	// static BinaryToSNA.main : String[] -> void
	/*********************************************************************
	** Application entry-point for converting a raw binary file to an SNA
	** file. This works by sewing the binary onto an existing SNA file.
	** @param argv The vector of command-line arguments. There should be
	**             four of these: an SNA file, a binary file,
	**             the name of the SNA file to save, and the start-address
	**             to locate the binary.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 4) {
			System.err.println("Usage: java BinaryToSNA "
			+ "<load.SNA> <binary_file> <save_as.SNA> "
			+ "<start_address>");
			System.exit(1);
		}
		
		Memory memory= new Memory();
		memory.loadSNA(argv[0]);

		FileInputStream binary= null;
		try {
			binary= new FileInputStream(argv[1]);
		} catch (FileNotFoundException fnfe) {
			System.err.println("BinaryToSNA.main: cannot open\""
			+ argv[1] + "\"");
			System.exit(1);
		}

		int address= 32768;
		try {
			address= Integer.parseInt(argv[3]);
		} catch (NumberFormatException nfe) {
			System.err.println(argv[3] + " doesn't parse as an "
			+ "integer!");
			System.exit(1);
		}

		try {
			int i;
			for (i= 0; binary.available() > 0; i++){
				memory._memory[address + i]
				= (byte)binary.read();
			}
		} catch (IOException ioe) {
			System.err.println("IOException thrown in " +
			                   "BinaryToSNA.main");
			System.exit(1);
		}
		memory.saveSNA(argv[2]);
	}
}
