      ////////////////////////////////////////
     // SPECSAISIE                          //
    // Written by Andrew Broad             ///
   //  BROADSOFT 2000                    ////
  //                                     /////
 // ByteSupport.java (2000:01:14 14:17) //////
/////////////////////////////////////////////
// Methods of ByteSupport:              ////
// - static twoByteValue                ///
// - static unsignByte                  //
/////////////////////////////////////////

/*****************************************************************************
** The class ByteSupport provides support functions for working with bytes.
*****************************************************************************/

public class ByteSupport {
	/********************************************************************/
	// ByteSupport.twoByteValue : (byte x byte) -> int
	/*********************************************************************
	** Interprets two bytes as an unsigned 16-bit integer.
	** @param l The low byte.
	** @param h The high byte.
	** @return The value of the two bytes as an unsigned 16-bit integer
	**         (l + 256*h).
	*********************************************************************/

	public static int twoByteValue (byte l, byte h) {
		return unsignByte(l) + 256 * unsignByte(h);
	}

	/********************************************************************/
	// ByteSupport.unsignByte : byte -> int
	/*********************************************************************
	** Reinterprets a byte as an unsigned 8-bit integer.
	** @param signedByte The byte to unsign.
	** @return The unsigned byte.
	*********************************************************************/

	public static int unsignByte (byte signedByte) {
		if (signedByte < 0)
			return signedByte + 256;
		else
			return signedByte;
	}
}
