      ////////////////////////////////////////
     // SPECSAISIE                          //
    // Written by Andrew Broad             ///
   //  BROADSOFT 2000                    ////
  //                                     /////
 // FixChecksum.java (2000:03:09 13:53) /////
////////////////////////////////////////////
// Methods of FixChecksum:              ///
// - static main                        //
/////////////////////////////////////////

import java.io.*;
import java.util.*;

/*****************************************************************************
** FixChecksum is an application class for loading a TAP file and resaving it,
** which has the effect of fixing any checksum errors (so you could edit a
** TAP file using a text editor, for example, and run it through this to fix
** the checksums).
*****************************************************************************/

public class FixChecksum {
	/********************************************************************/
	// static FixChecksum.main : String[] -> void
	/*********************************************************************
	** Application entry-point for loading and resaving a TAP file
	** in order to fix any checksum errors.
	** @param argv The vector of command-line arguments. There should be
        **             one of these: the TAP file to load and resave (it will
	**             be overwritten).
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 1) {
			System.err.println("Usage: java FixChecksum "
			+ "<file.TAP>");
			System.exit(1);
		}
		Tape tape= new Tape(argv[0]);
		tape.saveTAP(argv[0]);
		System.out.println("Resaved " + argv[0]);
	}
}
