      /////////////////////////////////
     // SPECSAISIE 1.2               //
    // Written by Andrew Broad      ///
   //  BROADSOFT 2003             ////
  //                              /////
 // Peek.java (2002:12:23 13:35) /////
/////////////////////////////////////
// Methods of Peek:              ///
// - static main                 //
//////////////////////////////////

import java.io.*;

/*****************************************************************************
** Peek is an application class for PEEKing a range of addresses in an SNA
** file.
*****************************************************************************/

public class Peek {
	static Memory _memory;

	/********************************************************************/
	// static Peek.main : String[] -> void
	/*********************************************************************
	** Application entry-point for PEEKing an SNA file.
	** @param argv The vector of command-line arguments. There should be
	**             at least two arguments: an SNA file to load, a
	**             start-address, and an optional stop-address (which
	**             defaults to the start-address).
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length < 2 || argv.length > 3) {
			System.err.println("Usage: java Peek <file.SNA> "
			+ "<start_address> (<stop_address>)");
			System.exit(1);
		}

		int startAddress= 0;
		try {
			startAddress= Integer.parseInt(argv[1]);
		} catch (NumberFormatException nfe) {
			System.err.println(argv[1] + " doesn't parse as an "
			+ "integer!");
			System.exit(1);
		}

		int stopAddress= startAddress;
		if (argv.length == 3) {
			try {
				stopAddress= Integer.parseInt(argv[2]);
			} catch (NumberFormatException nfe) {
				System.err.println(argv[2] + " doesn't parse"
				+ " as an integer!");
				System.exit(1);
			}
		}

		_memory= new Memory();
		_memory.loadSNA(argv[0]);

		for (int address= startAddress; address <= stopAddress;
		                                address++)
		{
			System.out.println(address + ": "
			+ ByteSupport.unsignByte(_memory.peek(address)));
		}
	}
}
