      /////////////////////////////////
     // SPECSAISIE 1.2               //
    // Written by Andrew Broad      ///
   //  BROADSOFT 2003             ////
  //                              /////
 // Poke.java (2002:12:23 13:34) /////
/////////////////////////////////////
// Methods of Poke:              ///
// - static main                 //
//////////////////////////////////

import java.io.*;

/*****************************************************************************
** Poke is an application class for applying a POKE to an SNA file.
*****************************************************************************/

public class Poke {
	static Memory _memory;

	/********************************************************************/
	// static Poke.main : String[] -> void
	/*********************************************************************
	** Application entry-point for POKEing an SNA file. It saves the SNA
	** file after the POKE has been applied.
	** @param argv The vector of command-line arguments. There should be
	**             three arguments: an SNA file to load, an address,
	**             and the byte to POKE into that address.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 3) {
			System.err.println("Usage: java Poke <file.SNA> "
			+ "<address> <byte>");
			System.exit(1);
		}

		int address= 0;
		try {
			address= Integer.parseInt(argv[1]);
		} catch (NumberFormatException nfe) {
			System.err.println(argv[1] + " doesn't parse as an "
			+ "integer!");
			System.exit(1);
		}

		byte bite= 0;
		try {
			bite= (byte)Integer.parseInt(argv[2]);
		} catch (NumberFormatException nfe) {
			System.err.println(argv[2] + " doesn't parse as an "
			+ "integer!");
			System.exit(1);
		}

		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		_memory.poke(address, bite);
		_memory.saveSNA(argv[0]);
	}
}
