      ////////////////////////////////////
     // SPECSAISIE 1.1                  //
    // Written by Andrew Broad         ///
   //  BROADSOFT 2002                ////
  //                                 ////
 // RoomJSW.java (2002:09:14 20:17) ////
///////////////////////////////////////
// Methods of RoomJSW:             ///
// - static main                   //
////////////////////////////////////

import java.io.*;

/*****************************************************************************
** RoomJSW is an application class for printing a room in a Jet Set Willy
** game.
*****************************************************************************/

public class RoomJSW {
	static Memory _memory;

	/********************************************************************/
	// static RoomJSW.printRoom : int -> void
	/*********************************************************************
	** Prints a room in the Jet Set Willy game.
	** @param room The room-number (0 to 63).
	*********************************************************************/

	private static void printRoom (int room) {
		ScreenLayout screen= new ScreenLayout();

		for (int o= 0; o <= 127; o++) {
			byte b= _memory._memory[49152 + 256*room + o];
			for (int i= 0; i <= 3; i++) {
				int c= b & ((byte)-64); // AND 11000000
				switch (c) {
					case    0: screen.addChr('.'); break;
					case   64: screen.addChr('-'); break;
					case -128: screen.addChr('|'); break;
					case  -64: screen.addChr('*'); break;
				}
				b<<= 2;
			}
		}
		screen.print();
		for (int i= 128; i <= 159; i++) {
			byte c= _memory._memory[49152 + 256*room + i];
			if (c < 32) c= 32;
			System.out.print((char)c);
		}
		System.out.println();
	}

	/********************************************************************/
	// static RoomJSW.main : String[] -> void
	/*********************************************************************
	** Application entry-point for printing a room in a Jet Set Willy
	** game.
	** @param argv The vector of command-line arguments. There should be
	**             one of these: an SNA file of the Jet Set Willy game.
	*********************************************************************/

	public static void main (String argv[]) {
		int room;

		if (argv.length != 2 || (room= Integer.parseInt(argv[1])) < 0
		                     || room > 63) {
			System.err.println("Usage: java RoomJSW <file.SNA> "
			+ "<room_number>");
			System.err.println("where {0 <= room_number <= 63}");
			System.exit(1);
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		printRoom(Integer.parseInt(argv[1]));
	}
}