      ///////////////////////////////////
     // SPECSAISIE 1.1                 //
    // Written by Andrew Broad        ///
   //  BROADSOFT 2002               ////
  //                                /////
 // RoomMM.java (2002:09:14 20:17) /////
///////////////////////////////////////
// Methods of RoomMM:              ///
// - static main                   //
////////////////////////////////////

import java.io.*;

/*****************************************************************************
** RoomMM is an application class for printing a room in a Manic Miner game.
*****************************************************************************/

public class RoomMM {
	static Memory _memory;

	/********************************************************************/
	// static RoomMM.printRoom : int -> void
	/*********************************************************************
	** Prints a room in the Manic Miner game.
	** @param room The room-number (0 to 63).
	*********************************************************************/

	private static void printRoom (int room) {
		ScreenLayout screen= new ScreenLayout();

		for (int o= 0; o <= 511; o++) {
			byte b= _memory._memory[45056 + 1024*room + o];
			if (b == _memory._memory[45056+1024*room+544]) {
				screen.addChr('.');
			}
			else if (b == _memory._memory[45056+1024*room+553]) {
				screen.addChr('-');
			}
			else if (b == _memory._memory[45056+1024*room+562]) {
				screen.addChr('_');
			}
			else if (b == _memory._memory[45056+1024*room+571]) {
				screen.addChr('|');
			}
			else if (b == _memory._memory[45056+1024*room+580]) {
				if (_memory._memory
				    [45056+1024*room+623] == 0)
				{
					screen.addChr('<');
				} else if (_memory._memory
				    [45056+1024*room+623] == 1)
				{
					screen.addChr('>');
				} else {
					screen.addChr('=');
				}
			}
			else if (b == _memory._memory[45056+1024*room+589]) {
				screen.addChr('*');
			}
			else if (b == _memory._memory[45056+1024*room+598]) {
				screen.addChr('!');
			}
			else if (b == _memory._memory[45056+1024*room+607]) {
				screen.addChr('+');
			}
			else {
				screen.addChr('?');
			}
		}
		screen.print();
		for (int i= 512; i <= 543; i++) {
			byte c= _memory._memory[45056 + 1024*room + i];
			if (c < 32) c= 32;
			System.out.print((char)c);
		}
		System.out.println();
	}

	/********************************************************************/
	// static RoomMM.main : String[] -> void
	/*********************************************************************
	** Application entry-point for printing a room in a Manic Miner game.
	** @param argv The vector of command-line arguments. There should be
	**             one of these: an SNA file of the Manic Miner game.
	*********************************************************************/

	public static void main (String argv[]) {
		int room;

		if (argv.length != 2 || (room= Integer.parseInt(argv[1])) < 0
		                     || room > 19) {
			System.err.println("Usage: java RoomMM <file.SNA> "
			+ "<room_number>");
			System.err.println("where {0 <= room_number <= 19}");
			System.exit(1);
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		printRoom(Integer.parseInt(argv[1]));
	}
}