      /////////////////////////////////////
     // SPECSAISIE                       //
    // Written by Andrew Broad          ///
   //  BROADSOFT 2000                 ////
  //                                  ////
 // RoomsJSW.java (2000:01:13 10:35) ////
////////////////////////////////////////
// Methods of RoomsJSW:             ///
// - static main                    //
/////////////////////////////////////

import java.io.*;

/*****************************************************************************
** RoomsJSW is an application class for printing a list of rooms in a Jet Set
** Willy game.
*****************************************************************************/

public class RoomsJSW {
	static Memory _memory;

	/********************************************************************/
	// static RoomsJSW.printRooms : void -> void
	/*********************************************************************
	** Prints a list of the rooms (number and name) in the Jet Set Willy
	** game.
	*********************************************************************/

	private static void printRooms () {
		for (int r= 0; r <= 63; r++) {
			if (r < 10) System.out.print(" ");
			System.out.print(r + ": \"");
			for (int i= 128; i <= 159; i++) {
				byte c= _memory._memory[49152 + 256*r + i];
				if (c < 32) c= 32;
				System.out.print((char)c);
			}
			System.out.println("\"");
		}
	}

	/********************************************************************/
	// static RoomsJSW.main : String[] -> void
	/*********************************************************************
	** Application entry-point for printing a list of rooms in a Jet Set
	** Willy game.
	** @param argv The vector of command-line arguments. There should be
	**             one of these: an SNA file of the Jet Set Willy game.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 1) {
			System.err.println("Usage: java RoomsJSW <file.SNA>");
			System.exit(1);
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		printRooms();
	}
}