      ////////////////////////////////////
     // SPECSAISIE                      //
    // Written by Andrew Broad         ///
   //  BROADSOFT 2000                ////
  //                                 ////
 // RoomsMM.java (2000:01:14 14:19) ////
///////////////////////////////////////
// Methods of RoomsMM:             ///
// - static main                   //
////////////////////////////////////

import java.io.*;

/*****************************************************************************
** RoomsMM is an application class for printing a list of rooms in a Manic
** Miner game.
*****************************************************************************/

public class RoomsMM {
	static Memory _memory;

	/********************************************************************/
	// static RoomsMM.printRooms : void -> void
	/*********************************************************************
	** Prints a list of the rooms (number and name) in the Manic Miner
	** game.
	*********************************************************************/

	private static void printRooms () {
		for (int r= 0; r <= 19; r++) {
			if (r < 10) System.out.print(" ");
			System.out.print(r + ": \"");
			for (int i= 512; i <= 543; i++) {
				byte c= _memory._memory[45056 + 1024*r + i];
				if (c < 32) c= 32;
				System.out.print((char)c);
			}
			System.out.println("\"");
		}
	}

	/********************************************************************/
	// static RoomsMM.main : String[] -> void
	/*********************************************************************
	** Application entry-point for printing a list of rooms in a Manic
	** Miner game.
	** @param argv The vector of command-line arguments. There should be
	**             one of these: an SNA file of the Manic Miner game.
	*********************************************************************/

	public static void main (String argv[]) {
		if (argv.length != 1) {
			System.err.println("Usage: java RoomsMM <file.SNA>");
			System.exit(1);
		}
		_memory= new Memory();
		_memory.loadSNA(argv[0]);
		printRooms();
	}
}