      /////////////////////////////////////////
     // SPECSAISIE                           //
    // Written by Andrew Broad              ///
   //  BROADSOFT 2002                     ////
  //                                      /////
 // ScreenLayout.java (2002:09:14 20:16) /////
/////////////////////////////////////////////
// Methods of ScreenLayout:             ////
// - addChr                             ///
// - print                              //
/////////////////////////////////////////

import java.io.*;

/*****************************************************************************
** ScreenLayout represents the screen layout of a MM/JSW room as a
** 2D character-array.
*****************************************************************************/

public class ScreenLayout {
	char[][] _layout= new char[16][32];
	int _row= 0;
	int _column= 0;

	/********************************************************************/
	// ScreenLayout.addChr : char -> void
	/*********************************************************************
	** Add a character to the screen layout and move to the next
	** character-position.
	** @param c The character to add.
	*********************************************************************/

	public void addChr (char c) {
		_layout[_row][_column]= c;
		_column++;
		if (_column > 31) {
			_column= 0;
			_row++;
		}
	}

	/********************************************************************/
	// ScreenLayout.print : void -> void
	/*********************************************************************
	** Print the screen layout.
	*********************************************************************/

	public void print () {
		for (int row= 0; row < 16; row++) {
			for (int column= 0; column < 32; column++) {
				System.out.print(_layout[row][column]);
			}
			System.out.println();
		}
	}
}